VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form6 
   BackColor       =   &H00C0FFC0&
   Caption         =   "Carte reseau"
   ClientHeight    =   5295
   ClientLeft      =   915
   ClientTop       =   1965
   ClientWidth     =   13725
   LinkTopic       =   "Form6"
   ScaleHeight     =   5295
   ScaleWidth      =   13725
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   495
      Left            =   5520
      TabIndex        =   1
      Top             =   4560
      Width           =   1215
   End
   Begin MSComctlLib.ListView ListView1 
      Height          =   4575
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   13695
      _ExtentX        =   24156
      _ExtentY        =   8070
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   12648384
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "Form6"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'--------------------------------------------------------------
' Copyright 1996-2002 VBnet, Randy Birch, All Rights Reserved.
' Terms of use http://www.mvps.org/vbnet/terms/pages/terms.htm
'--------------------------------------------------------------

'/* Below used for listview column auto-resizing
Private Const LVM_FIRST As Long = &H1000
Private Const LVM_SETCOLUMNWIDTH As Long = (LVM_FIRST + 30)
Private Const LVSCW_AUTOSIZE As Long = -1
Private Const LVSCW_AUTOSIZE_USEHEADER As Long = -2

Private Declare Function SendMessage Lib "user32" _
   Alias "SendMessageA" _
  (ByVal hwnd As Long, _
   ByVal wMsg As Long, _
   ByVal wParam As Long, _
   lParam As Any) As Long


Private Sub Form_Load()

   With ListView1
      .ListItems.Clear
      .ColumnHeaders.Clear
      .ColumnHeaders.Add , , "NIC"
      .ColumnHeaders.Add , , "MAC"
      .ColumnHeaders.Add , , "Addr IP"
      .ColumnHeaders.Add , , "Svr DHCP"
      .ColumnHeaders.Add , , "LeaseObt"
      .ColumnHeaders.Add , , "LeaseExp"
      .ColumnHeaders.Add , , "WINS"
      .ColumnHeaders.Add , , "Hostname"
      .ColumnHeaders.Add , , "Domain"
      .ColumnHeaders.Add , , "NIC Name"
      .View = lvwReport
      .Sorted = False
   End With
     
   Command1.Caption = "Get Adapter Config"

End Sub


Private Sub Command1_Click()

   ListView1.ListItems.Clear
   Call wmiNetAdapterConfig
   Call lvAutosizeControl(ListView1)
   
End Sub


Private Sub lvAutosizeControl(lv As ListView)

   Dim col2adjust As Long

  '/* Size each column based on the maximum of
  '/* EITHER the columnheader text width, or,
  '/* if the items below it are wider, the
  '/* widest list item in the column
   For col2adjust = 0 To lv.ColumnHeaders.Count - 1
   
      Call SendMessage(lv.hwnd, _
                       LVM_SETCOLUMNWIDTH, _
                       col2adjust, _
                       ByVal LVSCW_AUTOSIZE_USEHEADER)

   Next
   
End Sub


Private Function SplitDateTimeBias(ByVal leasedate As String, _
                                   leasedatepart As String, _
                                   leasetimepart As String) As Long

  'takes a datetime returned by the
  'Win32_NetworkAdapterConfiguration
  'and splits out the date and time
  'components, returns them in the
  'leasedatepart and leasetimepart
  'passed variables, and returns the
  'bias to be applied to the resultant date.
   Dim pos     As Long
   Dim bias    As Long
  
   pos = InStr(leasedate, ".")

   If pos > 0 Then

      bias = StripTimeZoneBias(leasedate)
      leasedatepart = Left$(leasedate, 8)
      leasetimepart = Mid$(leasedate, 9, pos - Len(leasedatepart) - 1)
      leasedatepart = InsertInString(leasedatepart, "-", 5, "")
      leasedatepart = InsertInString(leasedatepart, "-", 8, "")
      leasetimepart = InsertInString(leasetimepart, ":", 3, "")
      leasetimepart = InsertInString(leasetimepart, ":", 6, "")
      
      SplitDateTimeBias = bias

   Else

   End If

End Function


Private Function InsertInString(ByVal sOriginal As String, _
                                sReplace As String, _
                                nField As Long, _
                                sDelimeter As String) As String
    
   'c 1998 Mario Lavignasse
   'Abbott Scientific
   'Replaces or inserts a string into a (any char) delimeted string
   '
   'Syntax:
   'sOriginal:  string of interest, returned unchanged
   'sReplace:   replacement or insert chr(s)
   'nField:     1-based position for the insert/replace to begin
   'sDelimeter: string to insert/replace. If empty, sReplace is
   '            inserted, if present sDelimeter is replaced by sReplace.
   '
   'Examples:
   'Inserting:
   ' x = InsertInString("Hello World", "Hello ", 7, "")
   '  (x="Hello Hello World")
   '
   'Replacing:
   ' x = InsertInString("Hello World", "Hello ", 7, "World")
   '   (x="Hello Hello")
         
   Dim nCount As Long
   Dim nStart As Long
   Dim nLast As Long
    
   Do While InStr(nStart + 1, sOriginal, sDelimeter) > 0
    
      nStart = InStr(nStart + 1, sOriginal, sDelimeter)
      nCount = nCount + 1
      
      If nCount >= nField Then
         Exit Do
      End If
      
      nLast = nStart
        
   Loop
    
   
   Select Case nCount
   
      Case 1
         InsertInString = sReplace & Mid$(sOriginal, nStart)
      
      Case Is >= nField
         InsertInString = Mid$(sOriginal, 1, nLast) & _
                               sReplace & Mid$(sOriginal, nStart)
      Case Else
         InsertInString = sOriginal & _
                          String$((nField - 1) - nCount, sDelimeter) & _
                          sReplace
   End Select
    
End Function


Private Function StripTimeZoneBias(leasedate As String) As Long

   Dim pos As Long
   Dim tmp As String
   
   pos = InStr(leasedate, "-")
   
   If pos = 0 Then
      
      pos = InStr(leasedate, "+")
      
      If pos = 0 Then
         StripTimeZoneBias = 0
      Else
      
      End If
      
   Else
   
      tmp = Mid$(leasedate, pos, Len(leasedate))
      leasedate = Mid$(leasedate, 1, pos - 1)
      StripTimeZoneBias = CLng(tmp)
      
   End If

End Function


Private Sub wmiNetAdapterConfig()

   Dim nicSet As SWbemObjectSet
   Dim nic As SWbemObject
   
  'working vars for the lease date/times and listview
   Dim dtb As String
   Dim d As String
   Dim t As String
   Dim bias As Long
   Dim itmx As ListItem
   
  'must have error handler enabled, as all
  'adapters do not return all information
   On Local Error Resume Next
   
   Set nicSet = GetObject("winmgmts:{impersonationLevel=impersonate}"). _
                           InstancesOf("Win32_NetworkAdapterConfiguration")
   
   For Each nic In nicSet
   
      Set itmx = ListView1.ListItems.Add(, , nic.Index)
      
      itmx.SubItems(1) = nic.MACAddress
      
      If nic.IPEnabled Then
         itmx.SubItems(2) = nic.IpAddress(0)
      End If
          

      If nic.DHCPEnabled Then

         itmx.SubItems(3) = nic.DhcpServer
      
        'if DHCPLeaseObtained is not null,
        'call a method to extract the date,
        'time and bias (dtb) from the lease date
        'and show the results (time not shown)
         If Not IsNull(nic.DHCPLeaseObtained) Then
            dtb = nic.DHCPLeaseObtained
            bias = SplitDateTimeBias(dtb, d, t)
            itmx.SubItems(4) = Format$(d, "short date")
         End If
          
        'same again
         If Not IsNull(nic.DHCPLeaseExpires) Then
            dtb = nic.DHCPLeaseExpires
            bias = SplitDateTimeBias(dtb, d, t)
            itmx.SubItems(5) = Format$(d, "short date")
         End If
      
      End If

      itmx.SubItems(6) = nic.DNSEnabledForWINSResolution
      itmx.SubItems(7) = nic.DNSDomain
      itmx.SubItems(8) = nic.DNSHostName
      itmx.SubItems(9) = nic.Description
      
   Next

End Sub





