VERSION 5.00
Begin VB.Form Form9 
   BackColor       =   &H00C0FFC0&
   Caption         =   "Release / Renew"
   ClientHeight    =   2505
   ClientLeft      =   1125
   ClientTop       =   2190
   ClientWidth     =   13260
   LinkTopic       =   "Form9"
   ScaleHeight     =   2505
   ScaleWidth      =   13260
   Begin VB.CommandButton Command2 
      Caption         =   "Command2"
      Height          =   495
      Left            =   4680
      TabIndex        =   3
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   495
      Left            =   3360
      TabIndex        =   2
      Top             =   1920
      Width           =   1215
   End
   Begin VB.ListBox List2 
      BackColor       =   &H0080FF80&
      Height          =   1815
      Left            =   3360
      TabIndex        =   1
      Top             =   0
      Width           =   9855
   End
   Begin VB.ListBox List1 
      BackColor       =   &H00C0FFC0&
      Height          =   1815
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3375
   End
End
Attribute VB_Name = "Form9"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'--------------------------------------------------------------
' Copyright 1996-2002 VBnet, Randy Birch, All Rights Reserved.
' Terms of use http://www.mvps.org/vbnet/terms/pages/terms.htm
'--------------------------------------------------------------

Option Explicit

Private Sub Form_Load()

   ReDim TabArray(0 To 0) As Long
   TabArray(0) = 61
   
  'clear existing tabs and
  'set the list tabstops
   Call SendMessage(List2.hwnd, LB_SETTABSTOPS, 0&, ByVal 0&)
   Call SendMessage(List2.hwnd, LB_SETTABSTOPS, 1&, TabArray(0))
   List2.Refresh
  
  'initialize winsock and load adapter data
   SocketsInitialize
   DisplayAdatersInfo
 
   With Command1
      .Enabled = List1.ListIndex > -1
      .Caption = "Release IP"
   End With
   
   With Command2
      .Enabled = List1.ListIndex > -1
      .Caption = "Renew IP"
   End With
    
End Sub


Private Sub Form_Unload(Cancel As Integer)
    
    SocketsCleanup
    
End Sub


Private Sub Command1_Click()
   
   Dim ip_index As Long
   
   ip_index = CLng(List1.List(List1.ListIndex))
   
  'assure an adapter index has been selected
   If ip_index <> 0 Then
   
      Screen.MousePointer = vbHourglass
      
     'release the IP for the selected adapter
      If IPRelease(ip_index) Then
      
        'settings have changed, so
        'update the display
         DisplayAdatersInfo
         
      End If
      
      Screen.MousePointer = vbDefault
      
   End If

End Sub


Private Sub Command2_Click()

   Dim ip_index As Long
   
   ip_index = CLng(List1.List(List1.ListIndex))
   
  'assure an adapter index has been selected
   If ip_index <> 0 Then
   
      Screen.MousePointer = vbHourglass
      
     'release the IP for the selected adapter
      If IPRenew(ip_index) Then
      
        'settings have changed, so
        'update the display
         DisplayAdatersInfo
         
      End If
      
      Screen.MousePointer = vbDefault
      
   End If

End Sub


Private Sub List1_Click()

   Command1.Enabled = List1.ListIndex > -1
   Command2.Enabled = List1.ListIndex > -1

End Sub


Private Sub List1_MouseDown(Button As Integer, Shift As Integer, _
                            X As Single, Y As Single)

  'this just synchronizes selection in the
  'lists, for display purposes only
   List2.ListIndex = List1.ListIndex
   
End Sub


Private Sub List2_MouseDown(Button As Integer, Shift As Integer, _
                            X As Single, Y As Single)

  'this just synchronizes selection in the
  'lists, for display purposes only
   List1.ListIndex = List2.ListIndex
   
End Sub


Sub DisplayAdatersInfo()

  'populates two listboxes with adapter info

  'working vars
   Dim buff()      As Byte
   Dim cbRequired  As Long
   Dim Adapter     As IP_ADAPTER_INFO
   Dim ptr1        As Long
   
  'clear the lists
   List1.Clear
   List2.Clear
      
  'call GetAdaptersInfo with null as the
  'buffer to have the API return the needed
  'buffer size in cbRequired.
   Call GetAdaptersInfo(ByVal 0&, cbRequired)

   If cbRequired > 0 Then
   
      ReDim buff(0 To cbRequired - 1) As Byte
      
      If GetAdaptersInfo(buff(0), cbRequired) = ERROR_SUCCESS Then
   
         ptr1 = VarPtr(buff(0))
         
        'ptr1 is 0 when no more adapters
         Do While (ptr1 <> 0)
         
           'copy the pointer to the first adapter
           'into the IP_ADAPTER_INFO type
            CopyMemory Adapter, ByVal ptr1, LenB(Adapter)
         
            With Adapter
         
              'The only thing we need to use
              'release/renew is the Adapter.dwIndex
              'value, added to list1. Data in List2
              'is purely for show, and is not
              'required to release or renew.
               List1.AddItem .dwIndex
               List2.AddItem TrimNull(StrConv(.IpAddressList.IpAddress.IpAddr, vbUnicode)) _
                             & vbTab & _
                             TrimNull(StrConv(.sDescription, vbUnicode))
               
               ptr1 = .dwNext
               
            End With  'With Adapter
            
         Loop  'Do While (ptr1 <> 0)
         
      End If
   End If

End Sub

Private Function TrimNull(item As String)

    Dim pos As Integer
   
   'double check that there is a chr$(0) in the string
    pos = InStr(item, Chr$(0))
    If pos Then
          TrimNull = Left$(item, pos - 1)
    Else: TrimNull = item
    End If
  
End Function





