VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form4 
   BackColor       =   &H00C0FFC0&
   Caption         =   "Pci"
   ClientHeight    =   5820
   ClientLeft      =   705
   ClientTop       =   2190
   ClientWidth     =   13965
   LinkTopic       =   "Form4"
   ScaleHeight     =   5820
   ScaleWidth      =   13965
   Begin MSComctlLib.ListView ListView1 
      Height          =   5055
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   13935
      _ExtentX        =   24580
      _ExtentY        =   8916
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   12648384
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   495
      Left            =   4920
      TabIndex        =   0
      Top             =   5160
      Width           =   1215
   End
End
Attribute VB_Name = "Form4"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'--------------------------------------------------------------
' Copyright 1996-2002 VBnet, Randy Birch, All Rights Reserved.
' Terms of use http://www.mvps.org/vbnet/terms/pages/terms.htm
'--------------------------------------------------------------

'Below used for listview column auto-resizing
Private Const LVM_FIRST As Long = &H1000
Private Const LVM_SETCOLUMNWIDTH As Long = (LVM_FIRST + 30)
Private Const LVSCW_AUTOSIZE As Long = -1
Private Const LVSCW_AUTOSIZE_USEHEADER As Long = -2

Private Declare Function SendMessage Lib "user32" _
   Alias "SendMessageA" _
  (ByVal hwnd As Long, _
   ByVal wMsg As Long, _
   ByVal wParam As Long, _
   lParam As Any) As Long


Private Sub Form_Load()
Form1.Caption = "Info Pci"
   With ListView1
      .ListItems.Clear
      .ColumnHeaders.Clear
      .View = lvwReport
      .Sorted = False
   End With
   
   Command1.Caption = "Info Pci"

End Sub


Private Sub Command1_Click()

   ListView1.ListItems.Clear
   Call wmiSystemSlotInfo
   Call lvAutosizeControl(ListView1)
   
End Sub


Private Sub lvAutosizeControl(lv As ListView)

   Dim col2adjust As Long

  'Size each column based on the maximum of
  'either the ColumnHeader text width, or,
  'if the items below it are wider, the
  'widest list item in the column
   For col2adjust = 0 To lv.ColumnHeaders.Count - 1
   
      Call SendMessage(lv.hwnd, _
                       LVM_SETCOLUMNWIDTH, _
                       col2adjust, _
                       ByVal LVSCW_AUTOSIZE_USEHEADER)

   Next
   
End Sub


Private Sub wmiSystemSlotInfo()

   Dim wmiObjSet  As SWbemObjectSet
   Dim obj        As SWbemObject
   Dim thiscol    As Long
   Dim capcount   As Long
   Dim msg        As String
   Dim cnt        As Long
   Dim sflag      As String  'used in err trap
   Dim itmx       As ListItem

   On Local Error GoTo systemslot_error
   
  'add first column and set initial parameters
   With ListView1
      .ListItems.Clear
      .View = lvwReport
      .Sorted = False
      .ColumnHeaders.Clear
      .ColumnHeaders.Add , , "WMI Property"
      .ListItems.Add , , "Number"
      .ListItems.Add , , "Description"
      .ListItems.Add , , "Tag"
      .ListItems.Add , , "Status"
      .ListItems.Add , , "ConnectorPinout"
      .ListItems.Add , , "CurrentUsage"
      .ListItems.Add , , "MaxDataWidth"
      .ListItems.Add , , "PMESignal"
      .ListItems.Add , , "Shared"
      .ListItems.Add , , "SupportsHotPlug"
      .ListItems.Add , , "VccMixedVoltageSupport"
      .ListItems.Add , , "ConnectorType"

   End With

   Set wmiObjSet = GetObject("winmgmts:{impersonationLevel=impersonate}"). _
                                           InstancesOf("Win32_SystemSlot")
       
  'fill in respective columns for each object
   For Each obj In wmiObjSet
   
      With ListView1
         .ColumnHeaders.Add , , obj.SlotDesignation
         capcount = 0
         thiscol = (.ColumnHeaders.Count - 1)
         
         .ListItems(1).SubItems(thiscol) = IIf(obj.Number, obj.Number, "null")
         .ListItems(2).SubItems(thiscol) = obj.Description
         .ListItems(3).SubItems(thiscol) = obj.Tag
         .ListItems(4).SubItems(thiscol) = obj.Status
         .ListItems(5).SubItems(thiscol) = IIf(obj.ConnectorPinout, obj.ConnectorPinout, "null")
         
         Select Case obj.CurrentUsage
            Case 0: msg = "Reserved"
            Case 1: msg = "Other"
            Case 2: msg = "Unknown"
            Case 3: msg = "Available"
            Case 4: msg = "In use"
         End Select
         .ListItems(6).SubItems(thiscol) = msg
         
         Select Case obj.MaxDataWidth
            Case 0: msg = "8"
            Case 1: msg = "16"
            Case 2: msg = "32"
            Case 3: msg = "64"
            Case 4: msg = "128"
         End Select
         .ListItems(7).SubItems(thiscol) = msg
         
         .ListItems(8).SubItems(thiscol) = obj.PMESignal
         .ListItems(9).SubItems(thiscol) = obj.Shared
         .ListItems(10).SubItems(thiscol) = obj.SupportsHotPlug
         
         msg = ""
         For cnt = LBound(obj.VccMixedVoltageSupport) To UBound(obj.VccMixedVoltageSupport)
         
            Select Case obj.VccMixedVoltageSupport(cnt)
               Case 0: msg = msg & "Unknown  "
               Case 1: msg = msg & "Other  "
               Case 2: msg = msg & "3.3v  "
               Case 3: msg = msg & "5v  "
               Case Else: msg = ""
            End Select
            
         Next
         .ListItems(11).SubItems(thiscol) = msg
         
         sflag = "ConnectorType"
         For capcount = LBound(obj.ConnectorType) To UBound(obj.ConnectorType)
   
            Select Case obj.ConnectorType(capcount)
               Case 0: msg = " Unknown"
               Case 1: msg = " Other"
               Case 2: msg = " Male"
               Case 3: msg = " Female"
               Case 4: msg = " Shielded"
               Case 5: msg = " Unshielded"
               Case 6: msg = " SCSI (A) High-Density (50 pins)"
               Case 7: msg = " SCSI (A) Low-Density (50 pins)"
               Case 8: msg = " SCSI (P) High-Density (68 pins)"
               Case 9: msg = " SCSI SCA-I (80 pins)"
               Case 10: msg = "SCSI SCA-II (80 pins)"
               Case 11: msg = "SCSI Fibre Channel (DB-9, Copper)"
               Case 12: msg = "SCSI Fibre Channel (Fibre)"
               Case 13: msg = "SCSI Fibre Channel SCA-II (40 pins)"
               Case 14: msg = "SCSI Fibre Channel SCA-II (20 pins)"
               Case 15: msg = "SCSI Fibre Channel BNC"
               Case 16: msg = "ATA 3-1/2 Inch (40 pins)"
               Case 17: msg = "ATA 2-1/2 Inch (44 pins)"
               Case 18: msg = "ATA-2"
               Case 19: msg = "ATA-3"
               Case 20: msg = "ATA/66"
               Case 21: msg = "DB-9"
               Case 22: msg = "DB-15"
               Case 23: msg = "DB-25"
               Case 24: msg = "DB-36"
               Case 25: msg = "RS-232C"
               Case 26: msg = "RS-422"
               Case 27: msg = "RS-423"
               Case 28: msg = "RS-485"
               Case 29: msg = "RS-449"
               Case 30: msg = "V.35"
               Case 31: msg = "X.21"
               Case 32: msg = "IEEE-488"
               Case 33: msg = "AUI"
               Case 34: msg = "UTP Category 3"
               Case 35: msg = "UTP Category 4"
               Case 36: msg = "UTP Category 5"
               Case 37: msg = "BNC"
               Case 38: msg = "RJ11"
               Case 39: msg = "RJ45"
               Case 40: msg = "Fiber MIC"
               Case 41: msg = "Apple AUI"
               Case 42: msg = "Apple GeoPort"
               Case 43: msg = "PCI"
               Case 44: msg = "ISA"
               Case 45: msg = "EISA"
               Case 46: msg = "VESA"
               Case 47: msg = "PCMCIA"
               Case 48: msg = "PCMCIA Type I"
               Case 49: msg = "PCMCIA Type II"
               Case 50: msg = "PCMCIA Type III"
               Case 51: msg = "ZV Port"
               Case 52: msg = "CardBus"
               Case 53: msg = "USB"
               Case 54: msg = "IEEE 1394"
               Case 55: msg = "HIPPI"
               Case 56: msg = "HSSDC (6 pins)"
               Case 57: msg = "GBIC"
               Case 58: msg = "DIN"
               Case 59: msg = "Mini-DIN"
               Case 60: msg = "Micro-DIN"
               Case 61: msg = "PS/2"
               Case 62: msg = "Infrared"
               Case 63: msg = "HP-HIL"
               Case 64: msg = "Access.bus"
               Case 65: msg = "NuBus"
               Case 66: msg = "Centronics"
               Case 67: msg = "Mini-Centronics"
               Case 68: msg = "Mini-Centronics Type-14"
               Case 69: msg = "Mini-Centronics Type-20"
               Case 70: msg = "Mini-Centronics Type-26"
               Case 71: msg = "Bus Mouse"
               Case 72: msg = "ADB"
               Case 73: msg = "AGP"
               Case 74: msg = "VME Bus"
               Case 75: msg = "VME64"
               Case 76: msg = "Proprietary"
               Case 77: msg = "Proprietary Processor Card Slot"
               Case 78: msg = "Proprietary Memory Card Slot"
               Case 79: msg = "Proprietary I/O Riser Slot"
               Case 80: msg = "PCI-66MHZ"
               Case 81: msg = "AGP2X"
               Case 82: msg = "AGP4X"
   
            End Select
            
             .ListItems(12 + capcount).SubItems(thiscol) = msg
   
         Next
         sflag = ""
         
      End With
      
   Next
   
systemslot_exit:

   On Local Error GoTo 0
   Exit Sub
   
systemslot_error:

   If Err.Number = 35600 And sflag = "ConnectorType" Then
      ListView1.ListItems.Add 12 + capcount, , ""
      Resume
   Else
      Resume Next
   End If
   
End Sub





