VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form8 
   BackColor       =   &H00C0FFC0&
   Caption         =   "info disk"
   ClientHeight    =   6645
   ClientLeft      =   4965
   ClientTop       =   2190
   ClientWidth     =   5715
   LinkTopic       =   "Form8"
   ScaleHeight     =   6645
   ScaleWidth      =   5715
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   495
      Left            =   2160
      TabIndex        =   1
      Top             =   6120
      Width           =   1215
   End
   Begin MSComctlLib.ListView ListView1 
      Height          =   6015
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   5655
      _ExtentX        =   9975
      _ExtentY        =   10610
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   12648384
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "Form8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'--------------------------------------------------------------
' Copyright 1996-2002 VBnet, Randy Birch, All Rights Reserved.
' Terms of use http://www.mvps.org/vbnet/terms/pages/terms.htm
'--------------------------------------------------------------

'/* used for listview column auto-resizing
Private Const LVM_FIRST As Long = &H1000
Private Const LVM_SETCOLUMNWIDTH As Long = (LVM_FIRST + 30)
Private Const LVSCW_AUTOSIZE As Long = -1
Private Const LVSCW_AUTOSIZE_USEHEADER As Long = -2

Private Declare Function SendMessage Lib "user32" _
   Alias "SendMessageA" _
  (ByVal hwnd As Long, _
   ByVal wMsg As Long, _
   ByVal wParam As Long, _
   lParam As Any) As Long


Private Sub Form_Load()

   With ListView1
      .ListItems.Clear
      .ColumnHeaders.Clear
      .View = lvwReport
      .Sorted = False
   End With
   
   Command1.Caption = "Disk Info"

End Sub


Private Sub Command1_Click()

   ListView1.ListItems.Clear
   Call wmiDiskDriveInfo
   Call lvAutosizeControl(ListView1)
   
End Sub


Private Sub lvAutosizeControl(lv As ListView)

   Dim col2adjust As Long

  '/* Size each column based on the maximum of
  '/* EITHER the columnheader text width, or,
  '/* if the items below it are wider, the
  '/* widest list item in the column
   For col2adjust = 0 To lv.ColumnHeaders.Count - 1
   
      Call SendMessage(lv.hwnd, _
                       LVM_SETCOLUMNWIDTH, _
                       col2adjust, _
                       ByVal LVSCW_AUTOSIZE_USEHEADER)

   Next
   
End Sub


Private Sub wmiDiskDriveInfo()

   Dim DiskDriveSet As SWbemObjectSet
   Dim dd As SWbemObject
   Dim thiscol As Long
   Dim capcount As Long
   Dim msg As String
   Dim sflag As String  'used in err trap
   Dim itmx As ListItem

   On Local Error GoTo diskinfo_error
   
  'add a first column, and set lv initial parameters
   With ListView1
      .ListItems.Clear
      .View = lvwReport
      .Sorted = False
      .ColumnHeaders.Clear
      .ColumnHeaders.Add , , "WMI Property"
      
      'add class properties to column 1
      'identification info
      .ListItems.Add , , "ID: Description"
      .ListItems.Add , , "ID: Index"
      .ListItems.Add , , "ID: DeviceID"
      .ListItems.Add , , "ID: Caption"
      .ListItems.Add , , "ID: Manufacturer"
      .ListItems.Add , , "ID: Model"
      .ListItems.Add , , "ID: InterfaceType"
      .ListItems.Add , , "ID: MediaLoaded"
      .ListItems.Add , , "ID: MediaType"
      
      'physical info
      .ListItems.Add , , "Phyical: Status"
      .ListItems.Add , , "Phyical: Size"
      .ListItems.Add , , "Phyical: Partitions"
      .ListItems.Add , , "Phyical: BytesPerSector"
      .ListItems.Add , , "Phyical: SectorsPerTrack"
      .ListItems.Add , , "Phyical: TotalCylinders"
      .ListItems.Add , , "Phyical: TotalHeads"
      .ListItems.Add , , "Phyical: TotalTracks"
      .ListItems.Add , , "Phyical: TracksPerCylinder"
      
      'capabilities of the device
      .ListItems.Add , , "Disk Capabilities:"
   End With

   Set DiskDriveSet = GetObject("winmgmts:{impersonationLevel=impersonate}"). _
                                           InstancesOf("Win32_DiskDrive")
       
  'for each drive, fill in respective columns
   For Each dd In DiskDriveSet
   
      With ListView1
         .ColumnHeaders.Add , , dd.Description & " " & dd.Index
         capcount = 0
         thiscol = (.ColumnHeaders.Count - 1)
         
         'add identification info
         .ListItems(1).SubItems(thiscol) = dd.Description
         .ListItems(2).SubItems(thiscol) = dd.Index
         .ListItems(3).SubItems(thiscol) = dd.DeviceID
         .ListItems(4).SubItems(thiscol) = dd.Caption
         .ListItems(5).SubItems(thiscol) = dd.Manufacturer
         .ListItems(6).SubItems(thiscol) = dd.Model
         .ListItems(7).SubItems(thiscol) = dd.InterfaceType
         .ListItems(8).SubItems(thiscol) = dd.MediaLoaded
         .ListItems(9).SubItems(thiscol) = dd.MediaType

         'add physical info
         .ListItems(10).SubItems(thiscol) = dd.Status
         .ListItems(11).SubItems(thiscol) = FormatNumber(dd.Size, 0)
         .ListItems(12).SubItems(thiscol) = dd.Partitions
         .ListItems(13).SubItems(thiscol) = FormatNumber(dd.BytesPerSector, 0)
         .ListItems(14).SubItems(thiscol) = FormatNumber(dd.SectorsPerTrack, 0)
         .ListItems(15).SubItems(thiscol) = FormatNumber(dd.TotalCylinders, 0)
         
         'note: the value for the TotalHeads property
         'is obtained through extended functions of
         'BIOS interrupt 13h. The value may be inaccurate
         'if the drive uses a translation scheme to
         'support high capacity disk sizes. Consult
         'the manufacturer for accurate drive
         'specifications
         .ListItems(16).SubItems(thiscol) = FormatNumber(dd.TotalHeads, 0)
         .ListItems(17).SubItems(thiscol) = FormatNumber(dd.TotalTracks, 0)
         .ListItems(18).SubItems(thiscol) = FormatNumber(dd.TracksPerCylinder, 0)
      
        'capabilities of the device
         
        'because different drives may have different
        'capabilites, the routine is coded such that
        'when an insertion is attempted against a
        'non-existant subitem index, the error trap
        'will add the additional row. The sflag
        'just assists in identifying the error
        'occured because of the capactities loop.
         sflag = "caploop"
         For capcount = LBound(dd.capabilities) To UBound(dd.capabilities)

            Select Case dd.capabilities(capcount)
               Case 0: msg = "Unknown "
               Case 1: msg = "Other "
               Case 2: msg = "Sequential Access "
               Case 3: msg = "Random Access "
               Case 4: msg = "Supports Writing "
               Case 5: msg = "Encryption "
               Case 6: msg = "Compression "
               Case 7: msg = "Supports Removable Media "
               Case 8: msg = "Manual Cleaning "
               Case 9: msg = "Automatic Cleaning "
               Case 10: msg = "SMART Notification "
               Case 11: msg = "Supports Dual Sided Media "
               Case 12: msg = "Ejection Prior to Drive Dismount Not Required"
            
            End Select
            
            .ListItems(19 + capcount).SubItems(thiscol) = msg
        
         Next
         sflag = ""
      
      End With
      
   Next
   
diskinfo_exit:

   On Local Error GoTo 0
   Exit Sub
   
diskinfo_error:

  'if "index out of bounds" error
  'and error occurred as result of
  'adding drive capabilities, add
  'a new blank listitem and resume
   If Err.Number = 35600 And sflag = "caploop" Then
      ListView1.ListItems.Add 19 + capcount, , ""
      Resume
   Else
      Resume Next
   End If

End Sub
